package infomat.algorithms;

import infomat.vectorspace.*;
import mro.util.*;
import mro.util.properties.*;

import java.util.Vector; 

/**
 * GroupingAlgorithm
 *      
 * @version          060309
 * @author           Magnus Rosell
 */
public abstract class GroupingAlgorithm 
    implements HasProperties, UniqueIdentifiable{

    protected Properties properties;
    protected UniqueIdentifier identifier;

    public abstract IObjectGrouping cluster(IMatrix matrix, IObjectSet set);
    
    public abstract String getInfoString();

    public abstract String getAlgorithmName();
    
    public abstract Vector getPropertyVector();
}
