package infomat.vectorspace;

import java.util.*;

public class Sorter{


	public static IObjectGrouping 
	makeWeightGroupingRelativeGroupingOfOtherSet(IObjectSet set, IObjectGrouping grouping, IMatrix matrix){
		
		// Tillverka ny gruppering
		IObjectGrouping coging = 
			new IObjectGrouping("Weight Grouping relative "+grouping.getName());

		HashMap<Integer, IObjectGroup> groupingMap = 
			new HashMap<Integer, IObjectGroup>();

		// Tillverka centroider och nya grupper
		Vector centroids = new Vector();
		Vector<IObjectGroup> groups = grouping.getGroups();
		for(int i=0; i<groups.size(); i++){
			IObjectGroup cog = groups.elementAt(i);
			HashMap<IObject, Float> centroid = cog.getRepresentation(matrix);
			centroids.add(centroid);

			// Denna grupp borde kopplas till sin "systergrupp"
			// Om man flyttar p en i grnssnittet 
			// borde den andra flja med ...
			//
			// Kanske en ny underklass: ConnectedIObjectGrouping ???
			//
			IObjectGroup newCOG = 
				new IObjectGroup("Weight Group relative "+cog.getString());
			//				 set.getIMatrix());
			coging.add(newCOG);
			groupingMap.put(i, newCOG);
		}


		// G igenom alla objekt och lgg i rtt nya grupp
		Vector<IObject> vec = set.getOrdered();
		for(int i=0; i<vec.size(); i++){
			IObject co = vec.elementAt(i);
			int gr=0;
			float grWeight=0.0f;
			for(int g=0; g<centroids.size(); g++){
				HashMap<IObject, Float> centroid = (HashMap<IObject, Float>)
				centroids.elementAt(g);
				Float w = centroid.get(co);
				if(w!=null && w>grWeight){
					gr=g;
					grWeight=w;
				}
			}
			IObjectGroup cog = groupingMap.get(gr);
			cog.add(co, grWeight);
			coging.add(co, i*10+gr);
		}

		// Sortera de nya grupperna efter vikten p varje objekt
		//coging.sort();

		return coging;
	}
	
	public static float compareObjectToCentroid(HashMap<IObject, Float> representation,
			HashMap<IObject, Float> centroid){
		float sim =0f;
		Set<Map.Entry<IObject, Float>> set = representation.entrySet();
		Iterator<Map.Entry<IObject, Float>> it = set.iterator();
		while(it.hasNext()){
			Map.Entry<IObject, Float> entry = it.next();
			Float f = centroid.get(entry.getKey());
			if(f!=null){
				sim+= f * entry.getValue();
			}
		}
		return sim;
	}


	
	public static void sortInSimOrderWithinClusters(IMatrix matrix, Vector<IObjectGroup> groups){
		for(int g=0; g<groups.size(); g++){
			IObjectGroup group = groups.elementAt(g);
			HashMap<IObject, Float> centroid = group.getRepresentation(matrix);
			Vector<IObject> iobjects = group.getOrdered();
			group.removeAll();
			for(int i=0; i<iobjects.size(); i++){
				IObject io = iobjects.elementAt(i);
				HashMap<IObject, Float> representation = io.getRepresentation(matrix);
				float sim = compareObjectToCentroid(representation, centroid);
				group.add(io, sim);
			}
			group.sortInOrderValueOrder();
		}
	}

	

}
