package infomat.view;

import java.awt.*;
import javax.swing.*;

/**
 * Takes care of starting everything up.
 */
public class MainWindow {

	private JFrame frame;

	private infomat.view.menu.Menu menu;

	private SessionFrame mySessionFrame;

	private InfomatModel infomatModel;

	public static final String VERSION = "1.0";


	/**
	 * Run!
	 */
	public void run() {
		frame = new JFrame("Infomat");
		Container container = frame.getContentPane();

		infomatModel = new InfomatModel(this);
		mySessionFrame = new SessionFrame(infomatModel);
		mySessionFrame.setLayout(new BoxLayout(mySessionFrame, BoxLayout.Y_AXIS));

		menu = new 
		infomat.view.menu.Menu(this, infomatModel, 
				mySessionFrame.getToolbarController(), 
				mySessionFrame.getInfomatView());
		container.add(mySessionFrame);


		frame.setJMenuBar(menu);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.pack();
		frame.setVisible(true);
	}






	/** Get the sessionFrame that is in MainWindow */
	public JFrame getMainFrame() {
		return frame;
	}

	/** Get the frame that is in the MainWindows frame */
	public SessionFrame getSessionFrame() {
		return mySessionFrame;
	}

	/**
	 * Start Infomat Interface!
	 * 
	 * @param args
	 *            ignored
	 */
	public static void main(String args[]) {
		new MainWindow().run();
	}
}
