package infomat.view.grouping;

import infomat.vectorspace.*;
import infomat.view.*;

import javax.swing.*;

import java.awt.*;

import java.util.*;
import javax.swing.border.*;

/**
 * Displayer of info. The hub in this package.
 *
 */
public class GroupingPanel extends JPanel 
implements Observer{

	private InfomatModel model;
	private InfomatView view;

	private JPanel colPanel;
	private JPanel rowPanel;

	private GroupingSelectionPanel colShowPanel;
	private GroupingSelectionPanel rowShowPanel;

	private GroupingSelectionPanel colColorPanel;
	private GroupingSelectionPanel rowColorPanel;

	public final static int GROUPING_PANEL_HEIGHT=60;
	
	public GroupingPanel(InfomatModel model, InfomatView view){
		//super(new GridLayout(1,2));
		//	setPreferredSize(new Dimension(800, 450));
		this.model=model;
		this.view=view;

		putAll();
	}


	public void putAll(){
		removeAll();
		setLayout(new GridLayout(1,2));
		
		/*
		Dimension d = getPreferredSize();
		int width = (int) (d.getWidth()/2);
		int height = (int) d.getHeight();
		d = new Dimension(width, height);
		*/
		Dimension d = getSize();
		d = new Dimension((int)d.getWidth(), GROUPING_PANEL_HEIGHT);
		setPreferredSize(d);
		
		// Row
		rowPanel = new JPanel();
		rowPanel.setLayout(new GridLayout(2,1));
		boolean row=true;
		boolean col=false;
		rowShowPanel = new 
		GroupingSelectionPanel(model, view, row, col);
		rowShowPanel.setPreferredSize(d);
		rowShowPanel.setMinimumSize(d);
		rowShowPanel.setMaximumSize(d);
		rowShowPanel.setLayout(new BoxLayout(rowShowPanel, BoxLayout.X_AXIS));
		//	rowShowPanel.addActionListener(this);
		rowPanel.add(rowShowPanel);
		col=true;
		rowColorPanel = new GroupingSelectionPanel(model, view, row, col);
		rowColorPanel.setLayout(new BoxLayout(rowColorPanel, BoxLayout.X_AXIS));
		rowPanel.add(rowColorPanel);
		add(rowPanel);

		// Column
		colPanel = new JPanel();
		colPanel.setLayout(new GridLayout(2,1));
		row=false;
		col=false;
		colShowPanel = new 
			GroupingSelectionPanel(model, view, row, col);
		//	model.addObserver(colShowPanel);
		colShowPanel.setPreferredSize(d);
		colShowPanel.setMinimumSize(d);
		colShowPanel.setMaximumSize(d);

		colShowPanel.setLayout(new BoxLayout(colShowPanel, BoxLayout.X_AXIS));
		//	colShowPanel.addActionListener(this);
		colPanel.add(colShowPanel);

		col=true;
		colColorPanel = 
			new GroupingSelectionPanel(model, view, row, col);
		colColorPanel.setLayout(new BoxLayout(colColorPanel, BoxLayout.X_AXIS));
		colPanel.add(colColorPanel);
		add(colPanel);
		
		String rowTitle = view.getRowDimensionName()+" Groupings";
		String colTitle = view.getColumnDimensionName()+" Groupings"; //+": "+colCOS.getString()));
		
		if(model!=null && model.getIMatrix()!=null){

			IObjectSet rowCOS = model.getIMatrix().getRowIObjectSet();
			rowShowPanel.makeComboBox(rowCOS);
			rowColorPanel.makeComboBox(rowCOS);
			rowTitle += " ("+rowCOS.getString()+")";
			
			IObjectSet colCOS = model.getIMatrix().getColumnIObjectSet();
			colShowPanel.makeComboBox(colCOS);
			colColorPanel.makeComboBox(colCOS);
			colTitle += " ("+colCOS.getString()+")";
		}

		rowPanel.setBorder(new TitledBorder(rowTitle));
		colPanel.setBorder(new TitledBorder(colTitle));
		
		revalidate();
		repaint();

	}


	public void paintComponent(Graphics g) {
		super.paintComponent(g);
	}

	/** Called by the Observable */
	public void update(Observable o, Object arg) {
		putAll();
	}



}
