package infomat.view.grouping.settings;

import javax.swing.*;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import javax.swing.filechooser.FileFilter;

import java.awt.*;
import java.awt.event.*;
import java.io.File;

import infomat.vectorspace.*;
import infomat.view.*;
import infomat.view.picture.*;

public class GroupingFilePanel extends JPanel implements ActionListener{
	
	private InfomatModel model;
	private InfomatView view;
	private IObjectGrouping grouping;
	private boolean row;
	private boolean color;
	private JButton load;
	private JButton save;
	private JFileChooser fileChooser;
	private String fileChooserPath="";
	
	
	public GroupingFilePanel(InfomatModel model, InfomatView view, 
			IObjectGrouping grouping, boolean row, boolean color, Dimension d){
		this.model=model;
		this.view=view;
		this.grouping=grouping;
		this.row=row;
		this.color=color;

		fileChooserPath = (String) model.getPropertyValue("Matrix File Path");
		fileChooser = new JFileChooser(fileChooserPath);
		fileChooser.setFileFilter(new FileFilter() {
			public String getDescription() {
				return "XML files";
			}

			public boolean accept(File f) {
				if (f.isDirectory())
					return true;
				int findresult = f.getName().indexOf(".xml");
				int len = f.getName().length();
				return findresult != -1 && findresult == len - 4;
			}

		});


		
		
		Label l = new Label("File"); 
		add(l);
		
		
		load = new JButton("Load");
		load.addActionListener(this);
		save = new JButton("Save");
		save.addActionListener(this);
		
		add(load);
		add(save);
		
		/*
		Dimension d = getPreferredSize();
		int height = (int) l.getPreferredSize().getHeight();
		d = new Dimension(3*height, (int)d.getWidth());
		*/
		
		//Dimension d = new Dimension(50, 100); //new Dimension(l.getPreferredSize());
		setPreferredSize(d);
		setMaximumSize(d);
		setMinimumSize(d);

		JTextField dummy = new JTextField("Load");
		Dimension buttonSize = 
			new Dimension((int) load.getPreferredSize().getWidth(), 
					(int) dummy.getPreferredSize().getHeight());
		load.setPreferredSize(buttonSize);
		save.setPreferredSize(buttonSize);
		
	}
	
	
	
	public void actionPerformed(ActionEvent e) {
		if(e.getSource() instanceof JButton){
			if(e.getSource()==save){
				fileChooser.setSelectedFile(new File(""));
				if (fileChooser.showOpenDialog(model.getMainWindow().getSessionFrame()) == JFileChooser.APPROVE_OPTION) {
					model.saveIObjectGroupingFile(grouping, fileChooser.getSelectedFile());
				}
			}
			if(e.getSource()==load){
				fileChooser.setSelectedFile(new File(""));
				if (fileChooser.showOpenDialog(model.getMainWindow().getSessionFrame()) == JFileChooser.APPROVE_OPTION) {
					IObjectGrouping newGrouping = 
						model.openIObjectGroupingFile(row, fileChooser.getSelectedFile());
					
					if(newGrouping!=null){
						//Stt grupperingen! Vanlig eller frg?
						if(color)
							view.getGroupingManager(row).setCurrentColoringByGrouping(newGrouping);
						else{
							IObjectSet ios = model.getIMatrix().getColumnIObjectSet();
							if(row)
								ios = model.getIMatrix().getRowIObjectSet();
							ios.setGrouping(newGrouping);						
							model.resortIMatrix();
							view.resetImage();
						}
						view.forceChange();
						model.update();					
					}
				}
				
			}
		}
	}
 
	
}
